#ifndef GGAP_SCRIPT_H
#define GGAP_SCRIPT_H

#include <QObject>
#include <moo/unit-tests.h>

class QScriptEngine;
class QScriptValue;

namespace ggap {

class Worksheet;

class ScriptRunner : public QObject {
    Q_OBJECT

protected:
    virtual void setupEngine(QScriptEngine &engine, QScriptValue &global_obj);

public:
    ScriptRunner(QObject *parent = 0);
    ~ScriptRunner();

    void runScript(const QString &script);
};

class WorksheetScriptProxy : public ScriptRunner {
    Q_OBJECT
    MOO_DECLARE_UNIT_TESTS()

    Worksheet *ws;

protected:
    void setupEngine(QScriptEngine &engine, QScriptValue &global_obj);

public:
    WorksheetScriptProxy(Worksheet *ws);
    ~WorksheetScriptProxy();

    Q_INVOKABLE bool openUrl(const QString &url);
};

}

#endif // GGAP_SCRIPT_H
